<?php
namespace Geral\Repositories;

class Estruturah extends \Doctrine\ORM\EntityRepository
{
    public static function buscaNomeEstruturaLegal($nrEstrutLegal,$tipoEstrutLegal, $dtCompetencia, $nrOrgTrab){
        $sql = "SELECT ESTRUTURAH.NMRAZSOCESTRUT AS NMESTRUTLEGAL
                  FROM ESTRUTURAM
                  JOIN ESTRUTURAH
                    ON ESTRUTURAM.NRESTRUTURAM=ESTRUTURAH.NRESTRUTURAM
                   AND ESTRUTURAM.NRORG=ESTRUTURAH.NRORG
                   AND ESTRUTURAM.NRTIPOESTRUTURA = :TIPOESTRUTLEG
            INNER JOIN (SELECT MAX(DTMESCOMPETENC) DTMESCOMPETENC, NRESTRUTURAM, NRORG
                          FROM ESTRUTURAH
                         WHERE DTMESCOMPETENC <= :DTCOMPETENCIA
                      GROUP BY NRESTRUTURAM, NRORG) EHATUAL
                    ON (EHATUAL.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM
                   AND EHATUAL.NRORG = ESTRUTURAH.NRORG
                   AND EHATUAL.DTMESCOMPETENC = ESTRUTURAH.DTMESCOMPETENC)
                 WHERE ESTRUTURAH.NRORG = :NRORGTRABALHO
                   AND ESTRUTURAM.NRESTRUTURAM = :NRESTRUTLEGAL
              ORDER BY ESTRUTURAH.NMRAZSOCESTRUT";

        $params = array("TIPOESTRUTLEG" => $tipoEstrutLegal,
                        "DTCOMPETENCIA" => $dtCompetencia,
                        "NRORGTRABALHO" => $nrOrgTrab,
                        "NRESTRUTLEGAL" => $nrEstrutLegal);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch (\Exception $ex) {
            throw $ex;
        }
    }

    public function maxNrestruturah()
    {
        $sqlMax = "SELECT MAX(NRESTRUTURAH)+1 FROM ESTRUTURAH";
        $result = $this->getEntityManager()->getConnection()->fetchColumn($sqlMax);
        return ($result) ? $result : false;
    }

    /**
     * Pesquisa os feriados para a estrutura
     * @param String $dtinicio
     * @param String $dtfinal
     * @param int $nrestruturam
     * @param String $dtmescompetencia
     * @param int $nrorg
     * @return array
     */
    public static function getFeriados($dtinicio, $dtfinal, $nrestruturam, $dtmescompetencia, $nrorg)
    {

        $sql = <<<SQL
SELECT DISTINCT OCORCALENDARIO.DTCALENDARIO
FROM ESTRUTURAH
INNER JOIN OCORCALENDARIO
    ON OCORCALENDARIO.NRCALENDARIO = ESTRUTURAH.NRCALENDARIO
    AND OCORCALENDARIO.NRORG = ESTRUTURAH.NRORG
WHERE ESTRUTURAH.NRORG = $nrorg
    AND OCORCALENDARIO.DTCALENDARIO BETWEEN '$dtinicio' AND '$dtfinal'
    AND ESTRUTURAH.NRESTRUTURAM = $nrestruturam
    AND ESTRUTURAH.DTMESCOMPETENC = ( SELECT MAX(MAX_ESTRUTURAH.DTMESCOMPETENC)
                                    FROM ESTRUTURAH MAX_ESTRUTURAH
                                    WHERE MAX_ESTRUTURAH.DTMESCOMPETENC <= '$dtmescompetencia'
                                        AND MAX_ESTRUTURAH.NRORG = ESTRUTURAH.NRORG
                                        AND MAX_ESTRUTURAH.NRESTRUTURAM = ESTRUTURAH.NRESTRUTURAM)
SQL;
        //$result = \Setforms2\Shared\Connection::getInstance()->fetchAll($sql);
        $query = \Setforms2\Shared\Registry::getEntityManager()->getConnection()->prepare($sql);
        $query->execute();
        $result = $query->fetchAll();

        if($result)
            return $result;
        else
            return array();
    }
}